#version 150

#moj_import <fog.glsl>

in vec3 Position;
in vec2 UV0;
in vec4 Color;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;

out float vertexDistance;
out vec2 texCoord0;
out vec4 vertexColor;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);

    vertexDistance = fog_distance(ModelViewMat, Position, FogShape);
    float resultcol = linear_fog_fade(vertexDistance, 8, 15);
    vec4 outcolor = vec4(resultcol, resultcol, resultcol, Color.a);
    texCoord0 = UV0;
    vertexColor = outcolor * texelFetch(Sampler2, UV2 / 16, 0);
}
