#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform float GlintAlpha;

in float vertexDistance;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * ColorModulator;
    if (color.a < 0.1) {
        discard;
    }
    float fade = linear_fog_fade(vertexDistance, FogStart, FogEnd) * GlintAlpha;
    float desatcolor = color.g*0.59+color.r*0.3+color.b*0.11;
    vec4 finalcolor = vec4(color.r * 1, desatcolor, desatcolor, color.a);
    fragColor = vec4(finalcolor.rgb * fade, color.a);
}
